import {getInfo, login, logout, refreshToken} from '@/api/login'
import {getToken, removeToken, setExpiresIn, setToken} from '@/utils/auth'

const user = {
  state: {
    token: getToken(),
    id: '',
    name: '',
    avatar: '',
    roles: [],
    permissions: []
  },

  mutations: {
    SET_TOKEN: (state, token) => {
      state.token = token
    },
    SET_EXPIRES_IN: (state, time) => {
      state.expires_in = time
    },
    SET_ID: (state, id) => {
      state.id = id
    },
    SET_NAME: (state, name) => {
      state.name = name
    },
    SET_AVATAR: (state, avatar) => {
      state.avatar = avatar
    },
    SET_ROLES: (state, roles) => {
      state.roles = roles
    },
    SET_PERMISSIONS: (state, permissions) => {
      state.permissions = permissions
    }
  },

  actions: {
    // 登录
    Login({commit}, userInfo) {
      return new Promise((resolve, reject) => {
        let data = {
          "msg": "操作成功",
          "code": 200,
          "expires_in": 7200,
          "token": "eyJhbGciOiJIUzUxMiJ9.eyJsb2dpbl91c2VyX2tleSI6ImQyMzJhNThiLTY2MjQtNDU5Mi05NzUzLThjOTkwMzM2NDY1NSJ9.nSR8oEtL2Q80F2FTbcxgGTHP_5u0K3Itf_c10BmAL1hJU1_HsSSXApmcsGYGDRExH52JbjIaBVVwyrw6Xf5F5Q"
        }
        setToken(data.token)
        commit('SET_TOKEN', data.token)
        setExpiresIn(data.expires_in)
        commit('SET_EXPIRES_IN', data.expires_in)
        resolve()
      })
    },

    // 获取用户信息
    GetInfo({commit, state}) {
      return new Promise((resolve, reject) => {
        let res =  {
          "msg": "操作成功",
          "code": 200,
          "data": {
            "permissions": [
              "*:*:*"
            ],
            "roles": [
              "admin"
            ],
            "user": {
              "createBy": "admin",
              "createTime": "2023-04-23 16:11:38",
              "updateBy": null,
              "updateTime": null,
              "remark": "管理员",
              "userId": 1,
              "deptId": 103,
              "userName": "admin",
              "nickName": "智能车联",
              "email": "ry@163.com",
              "phonenumber": "15888888888",
              "sex": "1",
              "avatar": "",
              "status": "0",
              "delFlag": "0",
              "loginIp": "222.168.7.53",
              "loginDate": "2024-04-12T11:01:25.000+08:00",
              "dept": {
                "createBy": null,
                "createTime": null,
                "updateBy": null,
                "updateTime": null,
                "remark": null,
                "deptId": 103,
                "parentId": 101,
                "ancestors": "0,100,101",
                "deptName": "研发部门",
                "orderNum": 1,
                "leader": "智能车联",
                "phone": null,
                "email": null,
                "status": "0",
                "delFlag": null,
                "parentName": null,
                "children": []
              },
              "roles": [
                {
                  "createBy": null,
                  "createTime": null,
                  "updateBy": null,
                  "updateTime": null,
                  "remark": null,
                  "roleId": 1,
                  "roleName": "超级管理员",
                  "roleKey": "admin",
                  "roleSort": 1,
                  "dataScope": "1",
                  "menuCheckStrictly": false,
                  "deptCheckStrictly": false,
                  "status": "0",
                  "delFlag": null,
                  "flag": false,
                  "menuIds": null,
                  "deptIds": null,
                  "permissions": null,
                  "admin": true
                }
              ],
              "roleIds": null,
              "postIds": null,
              "roleId": null,
              "admin": true
            }
          }
        }
        const user = res.data.user
        const avatar = (user.avatar == "" || user.avatar == null) ? require("@/assets/images/profile.jpg") : user.avatar;
        if (res.data.roles && res.data.roles.length > 0) { // 验证返回的roles是否是一个非空数组
          commit('SET_ROLES', res.data.roles)
          commit('SET_PERMISSIONS', res.data.permissions)
        } else {
          commit('SET_ROLES', ['ROLE_DEFAULT'])
        }
        commit('SET_ID', user.userId)
        commit('SET_NAME', user.userName)
        commit('SET_AVATAR', avatar)
        resolve(res)
      })
    },

    // 退出系统
    LogOut({commit, state}) {
      return new Promise((resolve, reject) => {
        commit('SET_TOKEN', '')
        commit('SET_ROLES', [])
        commit('SET_PERMISSIONS', [])
        removeToken()
        resolve()
      })
    },

    // 前端 登出
    FedLogOut({commit}) {
      return new Promise(resolve => {
        commit('SET_TOKEN', '')
        removeToken()
        resolve()
      })
    }
  }
}

export default user
